//
//
//
//
//
//
//
//
//
//
// Microsoft Windows 95/98/NT Version 
//
//Copyright (c) 1994-1999 by Dan Higdon, Tim Little, and Chuck Walbourn
//
//
//
// This file and all associated files are subject to the terms of the
// GNU Lesser General Public License version 2 as published by the
// Free Software Foundation (http://www.gnu.org).   They remain the
// property of the authors: Dan Higdon, Tim Little, and Chuck Walbourn.
// See LICENSE.TXT in the distribution for a copy of this license.
//
// THE AUTHORS MAKE NO WARRANTIES, EXPRESS OR IMPLIED, AS TO THE CORRECTNESS
// OF THIS CODE OR ANY DERIVATIVE WORKS WHICH INCORPORATE IT.  THE AUTHORS
// PROVIDE THE CODE ON AN "AS-IS" BASIS AND EXPLICITLY DISCLAIMS ANY
// LIABILITY, INCLUDING CONSEQUENTIAL AND INCIDENTAL DAMAGES FOR ERRORS,
// OMISSIONS, AND OTHER PROBLEMS IN THE CODE.
//
//
//
//                        http://www.mythos-engine.org/
//
//
//
// Created by Tim Little & Chuck Walbourn
//
// escher.hpp
//
// Escher's C++ include header for the Escher library.  This includes all
// classes defined in the Escher library and associated functions and
// types, as well as some standard headers needed by the Escher library.
//
//

#ifndef __ESCHER_HPP
#define __ESCHER_HPP    1

//
//
//                                Includes
//
//

// Standard includes
#include <assert.h>
#include <string.h>
#include <math.h>

#include <portable.h>

// Supporting library includes
#include <ivory.hpp>
#include <felix.hpp>
#include <vangogh.hpp>

// Escher headers
#include "esdefs.h"

#include "eselemnt.hpp"

#include "esmath.hpp"                   // EschPoint, EschVector, EschVertex,
                                        // EschMatrix, EschFrameRef

#include "escontxt.hpp"                 // EschContext
#include "estxture.hpp"                 // EschTexture and derived classes
#include "eslight.hpp"                  // EschLight and derived classes
#include "escamera.hpp"                 // EschCamera and derived classes

#include "essystem.hpp"                 // EschSystem

#include "esdraw.hpp"                   // EschDrawable
#include "esbasic.hpp"                  // EschPointDraw
#include "espartik.hpp"                 // EschParticle and associated classes
#include "esgeom.hpp"                   // EschGeometry and associated classes

#include "eslimb.hpp"                   // EschLimbSegment & associated classes
#include "eskeyfrm.hpp"                 // EschKeyframer and associated classes

#include "esterran.hpp"                 // EschTerrain and derived classes

#include "espartn.hpp"                  // EschParition and associated classes

#include "esscene.hpp"                  // EschScene

#include "esbuild.hpp"                  // EschBuild classes

#include "esmisc.hpp"                   // Misc. Escher classes.

#endif

// End of header - escher.hpp 

